Index: trunk/DOC/BETA/Biblio/Biblio.bib
===================================================================
--- trunk/DOC/BETA/Biblio/Biblio.bib	(revision 781)
+++ trunk/DOC/BETA/Biblio/Biblio.bib	(revision 817)
@@ -85,4 +85,15 @@
 
 @STRING{Tellus = {Tellus}}
+
+@ARTICLE{Adcroft_Campin_OM04,
+  author = {A. Adcroft and J.-M. Campin},
+  title = {Re-scaled height coordinates for accurate representation of free-surface
+	flows in ocean circulation models},
+  journal = {Ocean Modelling},
+  year = {2004},
+  volume = {7},
+  owner = {gm},
+  timestamp = {2008.01.27}
+}
 
 @ARTICLE{Arakawa1966,
@@ -154,12 +165,12 @@
 
 @ARTICLE{Arhan2006,
-  author = {M. Arhan and A.M. Treguier and  B. Bourles and  S. Michel},
-  year = { 2006 },
-  title = {Diagnosing the annual cycle of the Equatorial Undercurrent in the Atlantic Ocean from a general circulation model},
-  journal =  JPO,
-  volume = { 36}, 
+  author = {M. Arhan and A.M. Treguier and B. Bourles and S. Michel},
+  title = {Diagnosing the annual cycle of the Equatorial Undercurrent in the
+	Atlantic Ocean from a general circulation model},
+  journal = JPO,
+  year = {2006},
+  volume = { 36},
   pages = {1502-1522}
 }
-
 
 @ARTICLE{ASSELIN1972,
@@ -185,4 +196,41 @@
   owner = {gm},
   timestamp = {2007.08.03}
+}
+
+@ARTICLE{Barnier_al_OD06,
+  author = {B. Barnier and G. Madec and T. Penduff and J.-M. Molines and A.-M.
+	Treguier and J. Le Sommer and A. Beckmann and A. Biastoch and C.
+	Boning and J. Dengg and C. Derval and E. Durand and S. Gulev and
+	E. Remy and C. Talandier and S. Theetten and M. Maltrud and J. McClean
+	and B. De Cuevas},
+  title = {Impact of partial steps and momentum advection schemes in a global
+	ocean circulation model at eddy-permitting resolution.},
+  journal = {Ocean Dyn.},
+  year = {2006},
+  pages = {doi: 10.1007/s10236-006-0082-1.},
+  owner = {gm},
+  timestamp = {2008.01.25}
+}
+
+@INCOLLECTION{Barnier1996,
+  author = {B. Barnier and P. Marchesiello and A.P. de Miranda},
+  title = {Modeling the ocean circulation in the South Atlantic: A strategy
+	for dealing with open boundaries},
+  booktitle = {The South Atlantic: Present and Past Circulation},
+  publisher = {Springer-Verlag, Berlin},
+  year = {1996},
+  editor = {G.Wefer and W.H. Berger and G Siedler and D. Webb},
+  pages = {289-304}
+}
+
+@ARTICLE{Barnier1998,
+  author = {B. Barnier and P. Marchesiello and A. P. de Miranda and J.M. Molines
+	and M. Coulibaly},
+  title = {A sigma-coordinate primitive equation model for studying the circulation
+	in the South Atlantic I, Model configuration with error estimates},
+  journal = {Deep Sea Res.},
+  year = {1998},
+  volume = {45},
+  pages = {543-572}
 }
 
@@ -336,4 +384,14 @@
 }
 
+@ARTICLE{Blayo2005,
+  author = {E. Blayo and L. Debreu},
+  title = {Revisiting open boundary conditions from the point of view of characteristic
+	variables},
+  journal = {Ocean Modelling},
+  year = {2005},
+  volume = {9},
+  pages = {231-252}
+}
+
 @ARTICLE{Bougeault1989,
   author = {P. Bougeault and P. Lacarrere},
@@ -429,4 +487,16 @@
 }
 
+@ARTICLE{Campin_Goosse_Tel99,
+  author = {J. M. Campin and H. Goosse},
+  title = {Parameterization of density-driven downsloping flow for a coarse-resolution
+	ocean model in z-coordinate},
+  journal = {Tellus},
+  year = {1999},
+  volume = {51},
+  pages = {412-430},
+  owner = {gm},
+  timestamp = {2008.01.20}
+}
+
 @ARTICLE{Cox1987,
   author = {M. Cox},
@@ -435,7 +505,43 @@
   year = {1987},
   volume = {74},
-  pages = {1-5},
+  pages = {1-9},
   owner = {gm},
   timestamp = {2007.08.03}
+}
+
+@ARTICLE{Dorscher_Beckmann_JAOT00,
+  author = {R. D\"{o}scher and A. Beckmann},
+  title = {Effects of a Bottom Boundary Layer Parameterization in a Coarse-Resolution
+	Model of the North Atlantic Ocean},
+  journal = JAOT,
+  year = {2000},
+  volume = {17},
+  pages = {698-707},
+  owner = {gm},
+  timestamp = {2008.01.23}
+}
+
+@ARTICLE{Debreu_al_CG2008,
+  author = {L. Debreu and C. Vouland and E. Blayo},
+  title = {AGRIF: Adaptive Grid Refinement In Fortran},
+  journal = {Computers and Geosciences},
+  year = {2008},
+  volume = {34},
+  pages = {8-13},
+  owner = {gm},
+  timestamp = {2008.02.03}
+}
+
+@ARTICLE{Delecluse_Madec_Bk00,
+  author = {P. Delecluse and G. Madec},
+  title = {Ocean modelling and the role of the ocean in the climate system},
+  journal = {In \textit{Modeling the Earth's Climate and its Variability}, Les
+	Houches, Session, LXVII 1997,
+	
+	Eds. W. R. Holland, S. Joussaume and F. David, Elsevier Science,},
+  year = {2000},
+  pages = {237-313},
+  owner = {gm},
+  timestamp = {2008.02.03}
 }
 
@@ -449,4 +555,13 @@
   owner = {gm},
   timestamp = {2007.08.03}
+}
+
+@INCOLLECTION{Durran2001,
+  author = {D.R. Durran },
+  title = {Open boundary conditions: fact and fiction},
+  booktitle = {Advances in Mathematical Modelling of Atmosphere and Ocean Dynamics},
+  publisher = {Kluwer Academic Publishers},
+  year = {2001},
+  editor = {P.F. Hodnett}
 }
 
@@ -619,4 +734,13 @@
   owner = {gm},
   timestamp = {2007.08.03}
+}
+
+@TECHREPORT{Gibson_TR86,
+  author = {J. K. Gibson},
+  title = {Standard software development and maintenance},
+  institution = {Operational Dep., ECMWF, Reading, UK.},
+  year = {1986},
+  owner = {gm},
+  timestamp = {2008.02.03}
 }
 
@@ -883,4 +1007,13 @@
 }
 
+@ARTICLE{Killworth1992,
+  author = {P. D. Killworth},
+  title = {An equivalent-barotropic mode in the fine resolution Antarctic model},
+  journal = JPO,
+  year = {1992},
+  volume = {22},
+  pages = {1379-1387}
+}
+
 @ARTICLE{Killworth1991,
   author = {Killworth, P. D. and Stainforth, D. and Webb, D. J. and Paterson,
@@ -909,14 +1042,4 @@
   timestamp = {2007.08.03}
 }
-
-@ARTICLE{Killworth1992,
-  author = {P. D. Killworth},
-   year = {1992}, 
-  title = {An equivalent-barotropic mode in the fine resolution Antarctic model},
-  journal = JPO,
-  volume = {22},
-  pages = {1379-1387}
-}.
-
 
 @ARTICLE{Kolmogorov1942,
@@ -1043,4 +1166,16 @@
 }
 
+@ARTICLE{Lengaigne_al_JGR03,
+  author = {M. Lengaigne and G. Madec and G. Alory and C. Menkes},
+  title = {Sensitivity of the tropical Pacific Ocean to isopycnal diffusion
+	on tracer and dynamics},
+  journal = JGR,
+  year = {2003},
+  volume = {108 (C11)},
+  pages = {3345, doi:10.1029/2002JC001704},
+  owner = {gm},
+  timestamp = {2008.01.26}
+}
+
 @ARTICLE{Leonard1991,
   author = {B. P. Leonard},
@@ -1121,5 +1256,5 @@
   title = {La formation d'eau profonde et son impact sur la circulation r\'{e}gionale
 	en M\'{e}diterran\'{e}e Occidentale - une approche num\'{e}rique},
-  school = {Universit\'{e}Pierre et Marie Curie, Paris,  France, 194pp.},
+  school = {Universit\'{e}Pierre et Marie Curie, Paris, France, 194pp.},
   year = {1990},
   owner = {gm},
@@ -1254,4 +1389,14 @@
 }
 
+@ARTICLE{Marchesiello2001,
+  author = { P. Marchesiello and J. Mc Williams and A. Shchepetkin },
+  title = {Open boundary conditions for long-term integrations of Regional Oceanic
+	Models},
+  journal = {Ocean Modelling},
+  year = {2001},
+  volume = {3},
+  pages = {1-20}
+}
+
 @PHDTHESIS{MartiTh1992,
   author = {O. Marti},
@@ -1338,4 +1483,13 @@
 }
 
+@BOOK{Mesinger_Arakawa_Bk76,
+  title = {Numerical methods used in Atmospheric models},
+  publisher = {GARP Publication Series No 17},
+  year = {1976},
+  author = {F. Mesinger and A. Arakawa},
+  owner = {gm},
+  timestamp = {2008.02.09}
+}
+
 @ARTICLE{Murray1996,
   author = {R. J. Murray},
@@ -1387,4 +1541,18 @@
   owner = {gm},
   timestamp = {2007.08.03}
+}
+
+@ARTICLE{Pacanowski_Gnanadesikan_MWR98,
+  author = {R. C. Pacanowski and A. Gnanadesikan},
+  title = {Transient response in a z-level ocean model that resolves topography
+	
+	
+	with partial-cells},
+  journal = MWR,
+  year = {1998},
+  volume = {126},
+  pages = {3248-3270},
+  owner = {gm},
+  timestamp = {2008.01.26}
 }
 
@@ -1422,6 +1590,27 @@
 }
 
+@ARTICLE{Penduff2000,
+  author = {T. Penduff and B. Barnier and A. Colin de Verdi\`{e}re},
+  title = { Self-adapting open boundaries for a regional model of the eastern
+	North Atlantic},
+  journal = JGR,
+  year = {2000},
+  volume = {105},
+  pages = {11,279-11,297}
+}
+
+@ARTICLE{Penduff2007,
+  author = {T. Penduff and J. Le Sommer and B. Barnier and A.M. Treguier and
+	J. Molines and G. Madec},
+  title = {Influence of numerical schemes on current-topography interactions
+	in 1/4$^{\circ}$ global ocean simulations},
+  journal = {Ocean Science},
+  year = {2007},
+  volume = {?},
+  pages = {in revision}
+}
+
 @ARTICLE{Phillips1959,
-  author = {R. S.  Phillips},
+  author = {R. S. Phillips},
   title = {Dissipative Operators and Hyperbolic Systems of Partial Differential
 	Equations},
@@ -1433,4 +1622,15 @@
   owner = {gm},
   timestamp = {2007.08.10}
+}
+
+@ARTICLE{Redi_JPO82,
+  author = {M. H. Redi},
+  title = {Oceanic isopycnal mixing by coordinate rotation},
+  journal = JPO,
+  year = {1982},
+  volume = {13},
+  pages = {1154-1158},
+  owner = {gm},
+  timestamp = {2008.02.02}
 }
 
@@ -1466,4 +1666,13 @@
   owner = {gm},
   timestamp = {2007.08.04}
+}
+
+@INCOLLECTION{Roed1986,
+  author = {L.P. Roed and C.K. Cooper},
+  title = {Open boundary conditions in numerical ocean models},
+  booktitle = {Advanced Physical Oceanography Numerical Modelling},
+  publisher = { NATO ASI Series, vol. 186.},
+  year = {1986},
+  editor = {J.J. O'Brien}
 }
 
@@ -1804,12 +2013,25 @@
   timestamp = {2007.08.05}
 }
- 
+
 @ARTICLE{Treguier1992,
-  author = {A.M. Treguier},
-  year = { 1992},
-  title = {Kinetic energy analysis of an eddy resolving, primitive equation North Atlantic model},
-  journal = JGR, 
-  volume = {97}, 
+  author = {A.M. Tr\'{e}guier},
+  title = {Kinetic energy analysis of an eddy resolving, primitive equation
+	North Atlantic model},
+  journal = JGR,
+  year = {1992},
+  volume = {97},
   pages = {687-701}
+}
+
+@ARTICLE{Treguier2001,
+  author = {A.M Tr\'{e}guier and B. Barnier and A.P. de Miranda and J.M. Molines
+	and N. Grima and M. Imbard and G. Madec and C. Messager and T. Reynaud
+	and S. Michel},
+  title = {An Eddy Permitting model of the Atlantic circulation: evaluating
+	open boundary conditions},
+  journal = JGR,
+  year = {2001},
+  volume = {106},
+  pages = {22115-22129}
 }
 
@@ -1970,99 +2192,4 @@
   month = jul,
   owner = {gm}
-}
-
-@ARTICLE{Marchesiello2001,
-  author = { P. Marchesiello  and J. Mc Williams  and A. Shchepetkin },
-  title = {Open boundary conditions for long-term integrations of Regional Oceanic Models},
-  journal = {Ocean Modelling},
-  year = {2001},
-  volume = {3},
-  pages = {1-20}
-}
-
-@INCOLLECTION{Durran2001,
-  author = {D.R.  Durran },
-  title = {Open boundary conditions: fact and fiction},
-  booktitle = {Advances in Mathematical Modelling of Atmosphere and Ocean Dynamics},
-  year = {2001},
-  editor = {P.F. Hodnett},
-  publisher = {Kluwer Academic Publishers}
-}
-
-@ARTICLE{Treguier2001,
-  author = {A.M Treguier and  B. Barnier and A.P. de Miranda and J.M. Molines and N. Grima and M. Imbard and G. Madec and C. Messager and  T. Reynaud and S. Michel},
-  title = {An Eddy Permitting model of the Atlantic circulation: evaluating open boundary conditions},
-  journal = JGR,
-  year = {2001},
-  volume = {106},
-  pages = {22115-22129}
-}
-
-@ARTICLE{Blayo2005,
-  author = {E. Blayo and L. Debreu},
-  title = {Revisiting open boundary conditions from the point of view of characteristic variables},
-  journal = {Ocean Modelling}, 
-  year = {2005},
-  volume = {9},
-  pages = {231-252}
-}
-
-@ARTICLE{Barnier1998,
-   author = {B. Barnier  and P. Marchesiello and A. P. de Miranda and  J.M. Molines and M. Coulibaly}, 
-   title = {A sigma-coordinate primitive equation model for studying the circulation in the South Atlantic I, Model configuration with error estimates}, 
-   journal = {Deep Sea Res.}, 
-   volume = {45}, 
-   pages = {543-572}, 
-   year =  {1998}
-}
-
-@ARTICLE{Penduff2000,
-   author = {T. Penduff and B. Barnier  and A. Colin de Verdi\`{e}re}, 
-   title = { Self-adapting open boundaries for a regional model of the eastern North Atlantic},
-   journal = JGR,
-   volume = {105}, 
-   pages = {11,279-11,297}, 
-   year =  {2000}
-}
-
-@ARTICLE{Penduff2007,
-   author = {T. Penduff and J. Le Sommer and B. Barnier and A.M. Treguier and J. Molines and G. Madec},
-   title = {Influence of numerical schemes on current-topography interactions in 1/4$^{\circ}$ global ocean simulations},  
-   journal = {Ocean Science},
-   volume = {?}, 
-   pages = {in revision}, 
-   year =  {2007}
-}
-
-  
-@INCOLLECTION{Barnier1996,
-  author = { B. Barnier  and P. Marchesiello  and  A.P. de Miranda },
-  title = {Modeling the ocean circulation in the South Atlantic : A strategy for dealing with open boundaries},
-  booktitle = {The South Atlantic : Present and Past Circulation},
-  editor = {G.Wefer and  W.H. Berger and G Siedler and D. Webb},
-  publisher ={Springer-Verlag, Berlin},
-  pages = {289-304},
-   year =  {1996}
-}
-
-@INCOLLECTION{Roed1986,
-  author = {L.P. Roed  and  C.K. Cooper},
-  year =  {1986},
-  title = {Open boundary conditions in numerical ocean models},
-  booktitle = {Advanced Physical Oceanography Numerical Modelling}, 
-  editor = {J.J. O'Brien},
-  publisher = { NATO ASI Series, vol. 186.}
-}
-
-
-@INCOLLECTION{Delecluse2000,
-  author = {P. Delecluse},
-  title = {Ocean modelling and the role of the ocean in the climate system},
-  pages = {237-313},
-  booktitle = {Modeling the Earth's Climate and its Variability, Les Houches, 1997},
-  year = {2000},
-  editor = {W. R. Holland and  S. Joussaume and F. David},
-  owner = {gm},
-  timestamp = {2007.08.17}
 }
 