Index: branches/dev_002_LIM/NEMO/OPA_SRC/DIA/diafwb.F90
===================================================================
--- branches/dev_002_LIM/NEMO/OPA_SRC/DIA/diafwb.F90	(revision 827)
+++ branches/dev_002_LIM/NEMO/OPA_SRC/DIA/diafwb.F90	(revision 828)
@@ -20,5 +20,4 @@
    USE blk_oce         ! ???
    USE flxblk          ! atmospheric surface quantity
-   USE flxblk_2          ! atmospheric surface quantity
    USE lib_mpp         ! distributed memory computing library
 
Index: branches/dev_002_LIM/NEMO/OPA_SRC/DOM/domain.F90
===================================================================
--- branches/dev_002_LIM/NEMO/OPA_SRC/DOM/domain.F90	(revision 827)
+++ branches/dev_002_LIM/NEMO/OPA_SRC/DOM/domain.F90	(revision 828)
@@ -257,5 +257,5 @@
       ENDIF
 
-      IF( lk_ice_lim ) THEN
+      IF( lk_lim3 .OR. lk_lim2 ) THEN
          IF(lwp) WRITE(numout,*) '           ice model coupling frequency      nfice  = ', nfice
          IF( MOD( nitend - nit000 + 1, nfice) /= 0 ) THEN 
Index: branches/dev_002_LIM/NEMO/OPA_SRC/SBC/albedo.F90
===================================================================
--- branches/dev_002_LIM/NEMO/OPA_SRC/SBC/albedo.F90	(revision 827)
+++ branches/dev_002_LIM/NEMO/OPA_SRC/SBC/albedo.F90	(revision 828)
@@ -39,5 +39,5 @@
 #if defined key_lim3
       albice = 0.53  ,     &   !  albedo of melting ice in the arctic and antarctic (Shine & Hendersson-Sellers)
-#elif defined key_lim2
+#else
       albice = 0.50  ,     &   !  albedo of melting ice in the arctic and antarctic (Shine & Hendersson-Sellers)
 #endif
@@ -83,4 +83,5 @@
       !! * Modules used
 #if defined key_lim3
+      USE par_ice
       USE ice                   ! ???
 #elif defined key_lim2
Index: branches/dev_002_LIM/NEMO/OPA_SRC/SBC/flx_oce.F90
===================================================================
--- branches/dev_002_LIM/NEMO/OPA_SRC/SBC/flx_oce.F90	(revision 827)
+++ branches/dev_002_LIM/NEMO/OPA_SRC/SBC/flx_oce.F90	(revision 828)
@@ -37,5 +37,5 @@
 #if defined key_lim3 
    REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpl)    ::   &  !:
-#elif defined key_lim2 
+#else
    REAL(wp), PUBLIC, DIMENSION(jpi,jpj)    ::   &  !:
 #endif
@@ -55,5 +55,5 @@
 #if defined key_lim3 
    REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpl)    ::   &  !:
-#elif defined key_lim2 
+#else
    REAL(wp), PUBLIC, DIMENSION(jpi,jpj)    ::   &  !:
 #endif
Index: branches/dev_002_LIM/NEMO/OPA_SRC/SBC/flxblk.F90
===================================================================
--- branches/dev_002_LIM/NEMO/OPA_SRC/SBC/flxblk.F90	(revision 827)
+++ branches/dev_002_LIM/NEMO/OPA_SRC/SBC/flxblk.F90	(revision 828)
@@ -26,4 +26,5 @@
    USE prtctl          ! Print control
 #if defined key_lim3
+   USE par_ice
    USE ice
 #elif defined key_lim2
@@ -83,5 +84,5 @@
 
 CONTAINS
-#if ! defined key_lim2
+#if defined key_lim3
 
    SUBROUTINE flx_blk( psst )
@@ -220,11 +221,4 @@
       !!---------------------------------------------------------------------
 
-      !---------------------
-      !   Initilization    !
-      !---------------------
-#if ! defined key_lim3
-      tn_ice(:,:) = psst(:,:)
-#endif
-
       !  Determine cloud optical depths as a function of latitude (Chou et al., 1981).
       !  and the correction factor for taking into account  the effect of clouds 
@@ -712,5 +706,5 @@
 
 
-#elif defined key_lim2
+#else
 
    SUBROUTINE flx_blk( psst )
@@ -846,4 +840,11 @@
       !!---------------------------------------------------------------------
 
+      !---------------------
+      !   Initilization    !
+      !---------------------
+#if ! defined key_lim2
+      tn_ice(:,:) = psst(:,:)
+#endif
+
       !  Determine cloud optical depths as a function of latitude (Chou et al., 1981).
       !  and the correction factor for taking into account  the effect of clouds 
Index: branches/dev_002_LIM/NEMO/OPA_SRC/SBC/flxfwb.F90
===================================================================
--- branches/dev_002_LIM/NEMO/OPA_SRC/SBC/flxfwb.F90	(revision 827)
+++ branches/dev_002_LIM/NEMO/OPA_SRC/SBC/flxfwb.F90	(revision 828)
@@ -23,5 +23,4 @@
    USE blk_oce
    USE flxblk          ! bulk formulea
-   USE flxblk_2          ! bulk formulea
    USE daymod          ! calendar
 
Index: branches/dev_002_LIM/NEMO/OPA_SRC/phycst.F90
===================================================================
--- branches/dev_002_LIM/NEMO/OPA_SRC/phycst.F90	(revision 827)
+++ branches/dev_002_LIM/NEMO/OPA_SRC/phycst.F90	(revision 828)
@@ -49,5 +49,5 @@
       rt0_snow = 273.16_wp  ,  &  !: melting point of snow  (Kelvin)
       rt0_ice  = 273.16_wp  ,  &  !: melting point of ice   (Kelvin)
-#elif defined key_lim2
+#else
       rt0_snow = 273.15_wp  ,  &  !: melting point of snow  (Kelvin)
       rt0_ice  = 273.05_wp  ,  &  !: melting point of ice   (Kelvin)
@@ -68,5 +68,5 @@
       rhoic   = 917._wp       ,   &  !: density of sea ice (kg/m3)
       tmut    =   0.054       ,   &  !: decrease of seawater meltpoint with salinity
-#elif defined key_lim2
+#else
       rcdsn   =   0.22_wp     ,   &  !: conductivity of the snow
       rcdic   =   2.034396_wp ,   &  !: conductivity of the ice
@@ -189,5 +189,5 @@
          WRITE(numout,*) '          latent heat of fusion of fresh ice / snow = ', lfus    , ' J/kg'
          WRITE(numout,*) '          latent heat of subl.  of fresh ice / snow = ', lsub    , ' J/kg'
-#elif defined key_lim2
+#else
          WRITE(numout,*) '          density times specific heat for snow      = ', rcpsn   , ' J/m^3/K' 
          WRITE(numout,*) '          density times specific heat for ice       = ', rcpic   , ' J/m^3/K'