Index: trunk/NEMO/LIM_SRC_3/limdyn.F90
===================================================================
--- trunk/NEMO/LIM_SRC_3/limdyn.F90	(revision 833)
+++ trunk/NEMO/LIM_SRC_3/limdyn.F90	(revision 834)
@@ -6,5 +6,5 @@
 #if defined key_lim3
    !!----------------------------------------------------------------------
-   !!   'key_lim3' :                                   LIM sea-ice model
+   !!   'key_lim3' :                                 LIM3 sea-ice model
    !!----------------------------------------------------------------------
    !!    lim_dyn      : computes ice velocities
@@ -36,5 +36,5 @@
 
    !!----------------------------------------------------------------------
-   !!   LIM 2.0,  UCL-LOCEAN-IPSL (2005)
+   !!   LIM 3.0,  UCL-ASTR-LOCEAN-IPSL (2008)
    !! $Header: /home/opalod/NEMOCVSROOT/NEMO/LIM_SRC/limdyn.F90,v 1.5 2005/03/27 18:34:41 opalod Exp $
    !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt
@@ -58,11 +58,11 @@
       !!   1.0  !  01-04   (LIM)  Original code
       !!   2.0  !  02-08   (C. Ethe, G. Madec)  F90, mpp
-      !!   3.0  !  2007-03 (M.A. Morales Maqueda, S. Bouillon, M. Vancoppenolle) LIM3, EVP, C-grid
+      !!   3.0  !  2007-03 (M.A. Morales Maqueda, S. Bouillon, M. Vancoppenolle) 
+      !!                   LIM3, EVP, C-grid
       !!------------------------------------------------------------------------------------
       !! * Local variables
-      INTEGER ::   ji, jj, jl        ! dummy loop indices
+      INTEGER ::   ji, jj            ! dummy loop indices
       INTEGER :: i_j1, i_jpj         ! Starting/ending j-indices for rheology
-! nemo modif
-!        jhemis                      ! jhemis = 1 (NH) ; jhemis = -1 (SH)
+
       REAL(wp) ::   &
          ztairx, ztairy,          &  ! tempory scalars
@@ -70,8 +70,8 @@
          ztglx , ztgly ,          &
          zt11, zt12, zt21, zt22 , &
-         zustm, zsfrld, zsfrldm4, &
+         zustm,                   &
          zsfrldmx2, zsfrldmy2,    &
          zu_ice, zv_ice, ztair2
-! nemo modif
+
       REAL(wp),DIMENSION(jpj) ::   &
            zind,                     &  ! i-averaged indicator of sea-ice
@@ -86,6 +86,5 @@
       IF ( ln_limdyn ) THEN
 
-         ! Mean ice and snow thicknesses.          
-
+         ! ocean velocity
          u_oce(:,:)  = u_io(:,:) * tmu(:,:)
          v_oce(:,:)  = v_io(:,:) * tmv(:,:)
@@ -94,6 +93,6 @@
          old_v_ice(:,:) = v_ice(:,:) * tmv(:,:)
 
-         !                                         ! Rheology (ice dynamics)
-         !                                         ! ========
+         ! Rheology (ice dynamics)
+         ! ========
 
          !  Define the j-limits where ice rheology is computed
@@ -105,5 +104,4 @@
             IF(ln_ctl) CALL prt_ctl_info( 'lim_dyn  :    i_j1 = ', ivar1=i_j1, clinfo2=' ij_jpj = ', ivar2=i_jpj )
             CALL lim_rhg( i_j1, i_jpj )
-
          ELSE                                 ! optimization of the computational area
 
@@ -124,5 +122,4 @@
                i_j1 = MAX( 1, i_j1-1 )
                IF(ln_ctl) CALL prt_ctl_info( 'lim_dyn  : NH  i_j1 = ', ivar1=i_j1, clinfo2=' ij_jpj = ', ivar2=i_jpj )
-
                CALL lim_rhg( i_j1, i_jpj )
 
@@ -169,10 +166,7 @@
          ENDIF
 
-         !                                         ! Ice-Ocean stress
-         !                                         ! ================
+         ! Ice-Ocean stress
+         ! ================
          DO jj = 2, jpjm1
-!           jhemis = SIGN(1, jj - jeq )
-!           zsang  = REAL(jhemis) * sangvg
-!nemo new version modif
             zsang  = SIGN(1.e0, gphif(1,jj-1) ) * sangvg
 
@@ -193,8 +187,4 @@
                ztairy =  ( 2.0 - at_i(ji,jj) - at_i(ji,jj+1) ) * gtauy(ji,jj) / cai * cao
 
-!              ! test on oscillations
-!              ztairx = 0.0
-!              ztairy = 0.0
-
                zsfrldmx2 = at_i(ji,jj) + at_i(ji+1,jj)
                zsfrldmy2 = at_i(ji,jj) + at_i(ji,jj+1)
@@ -208,8 +198,11 @@
                ztglx   = zsfrldmx2 * rhoco * zmod * ( cangvg * zu_ice - zsang * zv_ice ) 
                ztgly   = zsfrldmy2 * rhoco * zmod * ( cangvg * zv_ice + zsang * zu_ice ) 
-
-!              ! test on oscillations
-!              ztglx  = 0.0
-!              ztgly  = 0.0
+!
+!              ! IMPORTANT
+!              ! these lignes are bound to prevent numerical oscillations
+!              ! in the ice-ocean stress
+!              ! They are physically ill-based. There is a cleaner solution
+!              ! to try (remember discussion in Paris Gurvan)
+!
                ztglx   = ztglx * exp( - zmod / 0.5 )
                ztgly   = ztglx * exp( - zmod / 0.5 )
@@ -281,7 +274,4 @@
         CALL prt_ctl(tab2d_1=at_i  , clinfo1=' lim_dyn  : at_i  :')
       ENDIF
-
-!OPA9_DYN LIM2.1 2005
-!END OPA9_DYN LIM2.1 2005
 
    END SUBROUTINE lim_dyn