Index: /branches/dev_001_SBC/CONFIG/GYRE/EXP00/namelist
===================================================================
--- /branches/dev_001_SBC/CONFIG/GYRE/EXP00/namelist	(revision 875)
+++ /branches/dev_001_SBC/CONFIG/GYRE/EXP00/namelist	(revision 876)
@@ -777,5 +777,7 @@
 !       namsbc_core  CORE bulk formulea
 !-----------------------------------------------------------------------
-!  cn_dir   directory in which the model is executed
+!  cn_dir         directory in which the model is executed
+!  ln_2m          logical flag to use air temp. and hum referenced at 2m instead 10m
+!  alpha_precip   multiplication factor for precipitation (total & snow)
 !
 !  THE ORDER OF THE FILES MATTER:
@@ -784,4 +786,6 @@
 &namsbc_core
    cn_dir       = './'
+   ln_2m        = .FALSE.
+   alpha_precip = 1.
    sn_wndi      =    'u10'        ,       24.         ,  'U_10_MOD',    .FALSE.        ,    1   ,    0    
    sn_wndj      =    'v10'        ,       24.         ,  'V_10_MOD',    .FALSE.        ,    1   ,    0    
Index: /branches/dev_001_SBC/CONFIG/GYRE_LOBSTER/EXP00/namelist
===================================================================
--- /branches/dev_001_SBC/CONFIG/GYRE_LOBSTER/EXP00/namelist	(revision 875)
+++ /branches/dev_001_SBC/CONFIG/GYRE_LOBSTER/EXP00/namelist	(revision 876)
@@ -778,5 +778,7 @@
 !       namsbc_core  CORE bulk formulea
 !-----------------------------------------------------------------------
-!  cn_dir   directory in which the model is executed
+!  cn_dir         directory in which the model is executed
+!  ln_2m          logical flag to use air temp. and hum referenced at 2m instead 10m
+!  alpha_precip   multiplication factor for precipitation (total & snow)
 !
 !  THE ORDER OF THE FILES MATTER:
@@ -785,4 +787,6 @@
 &namsbc_core
    cn_dir       = './'
+   ln_2m        = .FALSE.
+   alpha_precip = 1.
    sn_wndi      =    'u10'        ,       24.         ,  'U_10_MOD',    .FALSE.        ,    1   ,    0    
    sn_wndj      =    'v10'        ,       24.         ,  'V_10_MOD',    .FALSE.        ,    1   ,    0    
Index: /branches/dev_001_SBC/CONFIG/ORCA2_LIM/EXP00/1_namelist
===================================================================
--- /branches/dev_001_SBC/CONFIG/ORCA2_LIM/EXP00/1_namelist	(revision 875)
+++ /branches/dev_001_SBC/CONFIG/ORCA2_LIM/EXP00/1_namelist	(revision 876)
@@ -777,5 +777,7 @@
 !       namsbc_core  CORE bulk formulea
 !-----------------------------------------------------------------------
-!  cn_dir   directory in which the model is executed
+!  cn_dir         directory in which the model is executed
+!  ln_2m          logical flag to use air temp. and hum referenced at 2m instead 10m
+!  alpha_precip   multiplication factor for precipitation (total & snow)
 !
 !  THE ORDER OF THE FILES MATTER:
@@ -784,4 +786,6 @@
 &namsbc_core
    cn_dir       = './'
+   ln_2m        = .FALSE.
+   alpha_precip = 1.
    sn_wndi      =    'u10'        ,       24.         ,  'U_10_MOD',    .FALSE.        ,    1   ,    0    
    sn_wndj      =    'v10'        ,       24.         ,  'V_10_MOD',    .FALSE.        ,    1   ,    0    
Index: /branches/dev_001_SBC/CONFIG/ORCA2_LIM/EXP00/namelist
===================================================================
--- /branches/dev_001_SBC/CONFIG/ORCA2_LIM/EXP00/namelist	(revision 875)
+++ /branches/dev_001_SBC/CONFIG/ORCA2_LIM/EXP00/namelist	(revision 876)
@@ -777,5 +777,7 @@
 !       namsbc_core  CORE bulk formulea
 !-----------------------------------------------------------------------
-!  cn_dir   directory in which the model is executed
+!  cn_dir         directory in which the model is executed
+!  ln_2m          logical flag to use air temp. and hum referenced at 2m instead 10m
+!  alpha_precip   multiplication factor for precipitation (total & snow)
 !
 !  THE ORDER OF THE FILES MATTER:
@@ -784,4 +786,6 @@
 &namsbc_core
    cn_dir       = './'
+   ln_2m        = .FALSE.
+   alpha_precip = 1.
    sn_wndi      =    'u10'        ,       24.         ,  'U_10_MOD',    .FALSE.        ,    1   ,    0    
    sn_wndj      =    'v10'        ,       24.         ,  'V_10_MOD',    .FALSE.        ,    1   ,    0    