Index: branches/dev_001_SBC/NEMO/LIM_SRC_3/limthd_dh.F90
===================================================================
--- branches/dev_001_SBC/NEMO/LIM_SRC_3/limthd_dh.F90	(revision 884)
+++ branches/dev_001_SBC/NEMO/LIM_SRC_3/limthd_dh.F90	(revision 886)
@@ -16,4 +16,5 @@
    USE phycst           ! physical constants (OCE directory) 
    USE ice_oce          ! ice variables
+   USE sbc_oce          ! Surface boundary condition: ocean fields
    USE thd_ice
    USE iceini
@@ -338,5 +339,5 @@
             zjj                 = ( npb(ji) - 1 ) / jpi + 1
             zfsalt_melt(ji)     = zfsalt_melt(ji) +                           &
-                                  ( sss_io(zji,zjj) - sm_i_b(ji)   ) *        &
+                                  ( sss_m(zji,zjj) - sm_i_b(ji)   ) *         &
                                   a_i_b(ji) *                                 &
                                   MIN( zdeltah(ji,jk) , 0.0 ) * rhoic / rdt_ice 
@@ -368,5 +369,5 @@
             WRITE(numout,*) ' qlbbq_1d: ', qlbbq_1d(ji)
             WRITE(numout,*) ' s_i_new : ', s_i_new(ji)
-            WRITE(numout,*) ' sss_io  : ', sss_io(zji,zjj)
+            WRITE(numout,*) ' sss_m   : ', sss_m(zji,zjj)
          ENDIF
 
@@ -494,6 +495,6 @@
                            zswi2  * 0.26 /  &
                            ( 0.26 + 0.74 * EXP ( - 724300.0 * zgrr ) ) 
-                  zds         = zfracs*sss_io(zji,zjj) - s_i_new(ji)
-                  s_i_new(ji) = zfracs * sss_io(zji,zjj)
+                  zds         = zfracs*sss_m(zji,zjj) - s_i_new(ji)
+                  s_i_new(ji) = zfracs * sss_m(zji,zjj)
                ENDIF ! fc_bo_i
             END DO ! ji
@@ -567,5 +568,5 @@
                   zjj             = ( npb(ji) - 1 ) / jpi + 1
                   zfsalt_melt(ji) = zfsalt_melt(ji) +                         &
-                                   ( sss_io(zji,zjj) - sm_i_b(ji)   ) *       &
+                                   ( sss_m(zji,zjj) - sm_i_b(ji)   ) *        &
                                    a_i_b(ji) * &
                                    MIN( zdeltah(ji,jk) , 0.0 ) * rhoic / rdt_ice 
@@ -596,5 +597,5 @@
                 WRITE(numout,*) ' qlbbq_1d: ', qlbbq_1d(ji)
                 WRITE(numout,*) ' s_i_new : ', s_i_new(ji)
-                WRITE(numout,*) ' sss_io  : ', sss_io(zji,zjj)
+                WRITE(numout,*) ' sss_m   : ', sss_m(zji,zjj)
                 WRITE(numout,*) ' dh_i_bott : ', dh_i_bott(ji)
                 WRITE(numout,*) ' innermelt : ', innermelt(ji)
@@ -701,10 +702,10 @@
          fseqv_1d(ji)  = fseqv_1d(ji) + zihgnew * zfsalt_melt(ji) +           &
                           (1.0 - zihgnew) * rdmicif_1d(ji) *                  &
-                          ( sss_io(zji,zjj) - sm_i_b(ji) ) / rdt_ice
+                          ( sss_m(zji,zjj) - sm_i_b(ji) ) / rdt_ice
          ! new lines
          IF ( num_sal .EQ. 4 ) &
          fseqv_1d(ji)  = fseqv_1d(ji) + zihgnew * zfsalt_melt(ji) +           &
                           (1.0 - zihgnew) * rdmicif_1d(ji) *                  &
-                          ( sss_io(zji,zjj) - bulk_sal ) / rdt_ice
+                          ( sss_m(zji,zjj) - bulk_sal ) / rdt_ice
          ! Heat flux
          ! excessive bottom ablation energy (fsup) - 0 except if jpl = 1
@@ -775,5 +776,5 @@
 
          zsm_snowice  = ( rhoic - rhosn ) / rhoic *            &
-                        sss_io(zji,zjj) 
+                        sss_m(zji,zjj) 
 
          IF ( num_sal .NE. 2 ) zsm_snowice = sm_i_b(ji)
@@ -781,5 +782,5 @@
          IF ( num_sal .NE. 4 ) &
          fseqv_1d(ji)   = fseqv_1d(ji)   + &
-                          ( sss_io(zji,zjj) - zsm_snowice ) * &
+                          ( sss_m(zji,zjj) - zsm_snowice ) * &
                             a_i_b(ji)   * &
                           ( zhgnew(ji) - ht_i_b(ji) ) * rhoic / rdt_ice
@@ -787,5 +788,5 @@
          IF ( num_sal .EQ. 4 ) &
          fseqv_1d(ji)   = fseqv_1d(ji)   + &
-                          ( sss_io(zji,zjj) - bulk_sal    ) * &
+                          ( sss_m(zji,zjj) - bulk_sal    ) * &
                             a_i_b(ji)   * &
                           ( zhgnew(ji) - ht_i_b(ji) ) * rhoic / rdt_ice
@@ -804,5 +805,5 @@
          rdmicif_1d(ji) = rdmicif_1d(ji) + a_i_b(ji) &
                                          * ( zhgnew(ji) - ht_i_b(ji) ) * rhoic &
-                                         + ( zhnnew - ht_s_b(ji) ) * rhosn )
+                                         + ( zhnnew - ht_s_b(ji) ) * rhosn
 #endif
 !  Actualize new snow and ice thickness.